<?php
/*
Plugin Name: Time Since
Plugin URI: http://manalang.com/
Description: Displays the date/time of the entry with hover text that shows the elapsed time (e.g., 4 hours, 20 minites ago).  This plugin was inspired by NatBat's time_since() function (http://blog.natbat.co.uk/archive/2003/Jun/14/time_since).
Version: 0.9
Author: Rich Manalang
Author URI: http://manalang.com/archives/category/wordpress/
*/ 
function time_since($original) {
    global $post;

    // array of time period chunks
    $chunks = array(
        array(60 * 60 * 24 * 365 , 'лет'),
        array(60 * 60 * 24 * 30 , 'месяцев'),
        array(60 * 60 * 24 * 7, 'недель'),
        array(60 * 60 * 24 , 'дней'),
        array(60 * 60 , 'часов'),
        array(60 , 'минут'),
    );
    
    $today = time(); /* Current unix time  */
    $since = $today - strtotime($post->post_date);
    
    // $j saves performing the count function each time around the loop
    for ($i = 0, $j = count($chunks); $i < $j; $i++) {
        
        $seconds = $chunks[$i][0];
        $name = $chunks[$i][1];
        
        // finding the biggest chunk (if the chunk fits, break)
        if (($count = floor($since / $seconds)) != 0) {
            // DEBUG print "<!-- It's $name -->\n";
            break;
        }
    }
    
    $print = ($count == 1) ? '1 '.$name : "$count {$name}";
    
    if ($i + 1 < $j) {
        // now getting the second item
        $seconds2 = $chunks[$i + 1][0];
        $name2 = $chunks[$i + 1][1];
        
        // add second item if it's greater than 0
        if (($count2 = floor(($since - ($seconds * $count)) / $seconds2)) != 0) {
            $print .= ($count2 == 1) ? ', 1 '.$name2 : ", $count2 {$name2}";
        }
    }
    return '<a title="'.$print.' назад">'.$original.'</a>';
}

add_filter('the_date','time_since');
add_filter('the_time','time_since');
?>